#!/usr/bin/python
# -*- coding: utf-8 -*-
#mmm
#KOPR 1.0
#mmm

import sys
from PyQt4 import QtGui, QtCore
from time import sleep

fontsize = 9
#fontsize = 8 
fonttype = 'SansSerif'
#fonttype = 'Arial'

def Version():
    return 'KOPR - v0.77 beta'

def DefaultFont():
    font = QtGui.QFont(fonttype, fontsize)
    return font

def SmallFont():
    font = QtGui.QFont(fonttype, fontsize*0.9)
    return font

# Clickable QLineEdit
def clickable(widget):
    class Filter(QtCore.QObject):
        clicked = QtCore.pyqtSignal()
        def eventFilter(self, obj, event):
            if obj == widget:
                if event.type() == QtCore.QEvent.MouseButtonRelease:
                    if obj.rect().contains(event.pos()):
                        self.clicked.emit()
                        return True
                elif event.type() == QtCore.QEvent.KeyRelease:
                    self.clicked.emit()
                    return True
            return False
     
    filter = Filter(widget)
    widget.installEventFilter(filter)
    return filter.clicked

def Colorlist():
    return ['indigo','firebrick','indianred','darkolivegreen','olive','tomato','orangered','blueviolet','fuchsia','darkslategray','brown','dodgerblue','peru','chocolate','crimson','forestgreen',\
'darkgreen','darkviolet','saddlebrown','darkslateblue','mediumvioletred','red','deeppink','limegreen','darkmagenta','darkgoldenrod','maroon','navy','dimgrey','olivedrab','blue','darkblue','seagreen',\
'sienna','mediumblue','royalblue','green','midnightblue','darkcyan','teal','darkorchid','salmon','deepskyblue','darkred','steelblue','palevioletred','coral','purple','mediumslateblue','darkorange','darkslategrey']

def Markers():
    return [ ('o','circle'), ('v','triangle_down'), ('^','triangle_up'), ('<','triangle_left'), ('>','triangle_right'), ('8','octagon'), ('s','square'), ('p','pentagon'), ('*','star'), ('h','hexagon1'), ('H','hexagon2'), ('D','diamond'), ('d','thin_diamond'), ('P','plus_filled'), ('X','x_filled') ]

def Telescopes2():
    return ('Camera lens (ICQ code:A)','Binoculars (ICQ code:B)','Cassegrain reflector (ICQ code:C)','Schmidt reflector (ICQ code:D)',\
    'Twin catadioptric Newtonian binocular (ICQ code:F)','Coronagraph  (ICQ code:G)','Hyperboloid astro-camera (ICQ code:H)','Multiple-Mirror Telescope (ICQ code:I)',\
    'Jones-Bird telescope (ICQ code:J)','Klevtsov-Cassegrain  (ICQ code:K)','Newtonian reflector (ICQ code:L)','Maksutov reflector (ICQ code:M)',\
    '1x monocular - 2 identical lenses (ICQ code:N)','Opera glass (ICQ code:O)','Prime focus of a reflector (ICQ code:P)','Refractor (ICQ code:R)',\
    'Schmidt-Newtonian telescope (ICQ code:S)','Schmidt-Cassegrain reflector (ICQ code:T)','Coude focus of a reflector (ICQ code:U)',\
    'Volosov-Newtonian reflecting telescope (ICQ code:V)','Wright-Schmidt reflector (ICQ code:W)','Ritchey-Chretien telescope (ICQ code:Y)')

def CCDChips2():
    return ('APS-C CMOS for Canon Kiss Digital camera (ICQ code: CAC)','2048x2048 EEV 42-40 (ICQ code: EEV)','Sony ExViewHAD tm (ICQ code: EXV)',\
        'Fairchild CCD486 4000x4000 CCD (ICQ code: F48)','Sony ICX259AL (ICQ code: ICX)','Sony ICX285AL (ICQ code: ICY)','Sony ICX-424AL (ICQ code: ICZ)',\
        'KAF-1001E (ICQ code: K10)','KAF-1600 (ICQ code: K16)','KAF-0261E (ICQ code: K26)','KAF-3200ME (ICQ code: K32)','KAF-0400 (ICQ code: K40)',\
        'KAF-0401E (ICQ code: K41)','KAF-0402ME (ICQ code: K42)','KAF-0400E (ICQ code: K4E)','KAF-1602E (ICQ code: K6E)','KAF-6303E (ICQ code: K6F)',\
        'KAF-1603ME (ICQ code: K6M)','KAF-0401 (ICQ code: KA0)','KAI-11000M (ICQ code: KA1)','Kodak KAF-1301E (ICQ code: KA2)','KAF-09000 (ICQ code: KA9)',\
        'KAI-2000M (ICQ code: KAI)','Marconi 47-10 (ICQ code: M47)','Philips FT12 (ICQ code: PF1)','Sony 285AL (ICQ code: SAL)','SIA502AB (ICQ code: SIA)',\
        'TC-241 CCD chip (ICQ code: T24)','TC255 (ICQ code: T25)','TH7883CDA (ICQ code: TH7)','thinned TK1024, Tektronik 1K 1024x1024 (ICQ code: TK1)',\
        'Tektronik TK-1024-AV (ICQ code: TK2)')

def Cameras2():
    return ('Artemis 285AL-a (ICQ code: AAL)','APOGEE AP47p (ICQ code: Ap4)','Apogee Ap-7 or Ap-7p (ICQ code: Ap7)','Apogee Alta U9000 (ICQ code: Ap9)',\
        'ATIK 2HS (ICQ code: ATI)','BITRAN BT-11 (ICQ code: BT1)','Canon Kiss Digital camera (ICQ code: CKD)','DillCam (ICQ code: Dil)','Meade DSI Pro (ICQ code: DSI)',\
        'Finger Lakes Instrumentation (ICQ code: FLD)','Finger Lakes Instrumentation (ICQ code: FLI)','Finger Lakes Instrumentation (ICQ code: FL9)','Hi-Sis 24 (ICQ code: H24)',\
        'Mutoh CV-16II or CV-16 (ICQ code: MCV)','Starlight MX-916 (ICQ code: MX9)','Nikon D50 digital SLR camera (ICQ code: Nik)','Pictor 416 (ICQ code: PIC)',\
        'Pictor 216 XT (ICQ code: PIX)','Photometrics Star-I (ICQ code: PSI)','QHY-6 (ICQ code: QHY)','a Russian CCD camera (ICQ code: S1C)',\
        'SOHO LASCO C2-coronagraph camera (ICQ code: SC2)','SOHO LASCO C3-coronagraph camera (ICQ code: SC3)','SBIG ST-7E (ICQ code: SE7)','SBIG ST-8E (ICQ code: SE8)',\
        'SBIG STL-6303 (ICQ code: ST0)','SBIG ST-1001E (ICQ code: ST1)','SBIG ST-2000XM (ICQ code: ST2)','SBIG STL1301E (ICQ code: ST3)','SBIG ST402 (ICQ code: ST4)',\
        'SBIG ST-6V (ICQ code: ST6)','SBIG ST-7 (ICQ code: ST7)','SBIG ST-8 (ICQ code: ST8)','SBIG ST-9E (ICQ code: ST9)','StarLight Express SXL8 (ICQ code: STE)',\
        'SBIG STL-11000M (ICQ code: STL)','SBIG ST-10XME (ICQ code: STM)','SBIG ST-10E (ICQ code: STT)','SBIG ST8-XME (ICQ code: STX)','Starlight Xpress SXV-H9 (ICQ code: SXV)')

def Telescopes():
    return { 'Camera lens' : 'A' ,
             'Binoculars' : 'B',
             'Cassegrain reflector' : 'C',
             'Schmidt reflector' : 'D',
             'Twin catadioptric Newtonian binocular' : 'F',
             'Coronagraph ' : 'G',
             'Hyperboloid astro-camera' : 'H',
             'Multiple-Mirror Telescope' : 'I',
             'Jones-Bird telescope' : 'J',
             'Klevtsov-Cassegrain ' : 'K',
             'Newtonian reflector' : 'L',
             'Maksutov reflector' : 'M',
             '1x monocular - 2 identical lenses' : 'N',
             'Opera glass' : 'O',
             'Prime focus of a reflector' : 'P',
             'Refractor' : 'R',
             'Schmidt-Newtonian telescope' : 'S',
             'Schmidt-Cassegrain reflector' : 'T',
             'Coude focus of a reflector' : 'U',
             'Volosov-Newtonian reflecting telescope' : 'V',
             'Wright-Schmidt reflector' : 'W',
             'Ritchey-Chretien telescope' : 'Y' }

def Cameras():
    return { 'Artemis 285AL-a' : 'AAL',
             'APOGEE AP47p' : 'Ap4',
             'Apogee Ap-7 or Ap-7p' : 'Ap7',
             'Apogee Alta U9000' : 'Ap9',
             'ATIK 2HS' : 'ATI',
             'BITRAN BT-11' : 'BT1',
             'Canon Kiss Digital camera' : 'CKD',
             'DillCam' : 'Dil',
             'Meade DSI Pro' : 'DSI',
             'Finger Lakes Instrumentation' : 'FLD',
             'Finger Lakes Instrumentation' : 'FLI',
             'Finger Lakes Instrumentation' : 'FL9',
             'Hi-Sis 24' : 'H24',
             'Mutoh CV-16II or CV-16' : 'MCV',
             'Starlight MX-916' : 'MX9',
             'Nikon D50 digital SLR camera' : 'Nik',
             'Pictor 416' : 'PIC',
             'Pictor 216 XT' : 'PIX',
             'Photometrics Star-I' : 'PSI',
             'QHY-6' : 'QHY',
             'a Russian CCD camera' : 'S1C',
             'SOHO LASCO C2-coronagraph camera' : 'SC2',
             'SOHO LASCO C3-coronagraph camera' : 'SC3',
             'SBIG ST-7E' : 'SE7',
             'SBIG ST-8E' : 'SE8',
             'SBIG STL-6303' : 'ST0',
             'SBIG ST-1001E' : 'ST1',
             'SBIG ST-2000XM' : 'ST2',
             'SBIG STL1301E' : 'ST3',
             'SBIG ST402' : 'ST4',
             'SBIG ST-6V' : 'ST6',
             'SBIG ST-7' : 'ST7',
             'SBIG ST-8' : 'ST8',
             'SBIG ST-9E' : 'ST9',
             'StarLight Express SXL8' : 'STE',
             'SBIG STL-11000M' : 'STL',
             'SBIG ST-10XME' : 'STM',
             'SBIG ST-10E' : 'STT',
             'SBIG ST8-XME' : 'STX',
             'Starlight Xpress SXV-H9' : 'SXV' }

def CCDChips():
    return { 'APS-C CMOS for Canon Kiss Digital camera' : 'CAC',
             '2048x2048 EEV 42-40' : 'EEV',
             'Sony ExViewHAD tm' : 'EXV',
             'Fairchild CCD486 4000x4000 CCD' : 'F48',
             'Sony ICX259AL' : 'ICX',
             'Sony ICX285AL' : 'ICY',
             'Sony ICX-424AL' : 'ICZ',
             'KAF-1001E' : 'K10',
             'KAF-1600' : 'K16',
             'KAF-0261E' : 'K26',
             'KAF-3200ME' : 'K32',
             'KAF-0400' : 'K40',
             'KAF-0401E' : 'K41',
             'KAF-0402ME' : 'K42',
             'KAF-0400E' : 'K4E',
             'KAF-1602E' : 'K6E',
             'KAF-6303E' : 'K6F',
             'KAF-1603ME' : 'K6M',
             'KAF-0401' : 'KA0',
             'KAI-11000M' : 'KA1',
             'Kodak KAF-1301E' : 'KA2',
             'KAF-09000' : 'KA9',
             'KAI-2000M' : 'KAI',
             'Marconi 47-10' : 'M47',
             'Philips FT12' : 'PF1',
             'Sony 285AL' : 'SAL',
             'SIA502AB' : 'SIA',
             'TC-241 CCD chip' : 'T24',
             'TC255' : 'T25',
             'TH7883CDA' : 'TH7',
             'thinned TK1024, Tektronik 1K 1024x1024' : 'TK1',
             'Tektronik TK-1024-AV' : 'TK2' }

def Catalogs():
    return ( 'AQ, AAVSO Photometric All-Sky Survey', 
             'TK, Tycho-2 Catalogue Vt magnitudes', 
             'HI, Hipparcos Input Catalogue', 
             'HJ, Hipparcos photometric system Hp',
             'HV, Hipparcos Catalogue Johnson V magnitudes', 
             'TI, Tycho Input Catalogue', 
             'TJ, Tycho Catalogue Johnson V magnitudes',
             'TT, Tycho/Hipparcos Catalogue V_T magnitudes', 
             'GA, Guide Star Photometric Catalog - I', 
             'LA, Landolt photoelectric sequences' )

def MagSources():
    return [ ('APASS B mag', '&-out=Bmag') ,
             ('APASS V mag', '&-out=Vmag' ) ,
             ('APASS calc. R mag', '&-out=r\'mag&-out=i\'mag' ) ,
#             ('APASS calc. I mag', '&-out=Vmag&-out=r\'mag&-out=i\'mag' ) ,
             ('APASS calc. I mag', '&-out=Vmag&-out=g\'mag&-out=i\'mag' ) ,
             ('APASS g\' mag', '&-out=g\'mag' ) ,
             ('APASS r\' mag', '&-out=r\'mag' ) ,
             ('APASS i\' mag', '&-out=i\'mag' ) ]

def Filters():
    return [ ( 'Unfiltered - C', 0 ) ,
             ( 'Filter - B', 1 ) ,
             ( 'Filter - V', 2 ) ,
             ( 'Filter - R', 3 ) ,
             ( 'Filter - I', 4 ) ,
             ( 'Filter - g\'', 5 ) ,
             ( 'Filter - r\'', 6 ) ,
             ( 'Filter - i\'', 7 ) ]

def Corrections():
    return [ ( 'No correction' , 0 ) ,
             ( 'Bias', 1 ),
             ( 'Flat', 2 ),
             ( 'Flat + Bias', 3 ),
             ( 'Dark + Bias', 4 ),
             ( 'Dark + Flat + Bias', 5 ) ]

def Methods():
    return ( 'Morris', 'Sidgwick', 'Bobrovnikoff' )

def Extinct():
    return ( 'No Extinction', 'Winter', 'Spring/Autumn', 'Summer')            

def GetSunMag(flt):
    sunmag ={'C' : [ 0, 'C' ],
             'B' : [ -26.13, 'D' ],
             'V' : [ -26.78, 'V' ],
             'R' : [ -27.12, 'k' ],
             'I' : [ -27.47, 'H' ],
             'g\'':[ -26.36, 'x' ],
             'r\'':[ -27.08, 'y' ],
             'i\'':[ -27.42, 'z' ]   }

    return sunmag[flt][0], sunmag[flt][1]

def MagMethods(flt):
    magmethods = {}
    f = open('./config-files/magmethods.dat','r')
    methods = f.read()
    methods = methods.split('\n')
    for line in methods:
      try:
        item = line.split(':')[1]
        fname, icq, src = item.split(',')
        magmethods[fname] = [ icq, src ]
      except:
        pass

    return magmethods[flt]

def retsrc(peak):
    midpoints = { '445' : 0,
                  '464' : 4,
                  '551' : 1,
                  '658' : 2,
                  '806' : 3 }
    return midpoints[str(min([445,464,551,658,806], key=lambda x:abs(x-int(peak))))]








